// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/portalmetadata"
	"go.phucam.tv/ent/predicate"
)

// PortalMetadataDelete is the builder for deleting a PortalMetadata entity.
type PortalMetadataDelete struct {
	config
	hooks    []Hook
	mutation *PortalMetadataMutation
}

// Where appends a list predicates to the PortalMetadataDelete builder.
func (pmd *PortalMetadataDelete) Where(ps ...predicate.PortalMetadata) *PortalMetadataDelete {
	pmd.mutation.Where(ps...)
	return pmd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (pmd *PortalMetadataDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(pmd.hooks) == 0 {
		affected, err = pmd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*PortalMetadataMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			pmd.mutation = mutation
			affected, err = pmd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(pmd.hooks) - 1; i >= 0; i-- {
			if pmd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = pmd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, pmd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (pmd *PortalMetadataDelete) ExecX(ctx context.Context) int {
	n, err := pmd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (pmd *PortalMetadataDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: portalmetadata.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: portalmetadata.FieldID,
			},
		},
	}
	if ps := pmd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, pmd.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	return affected, err
}

// PortalMetadataDeleteOne is the builder for deleting a single PortalMetadata entity.
type PortalMetadataDeleteOne struct {
	pmd *PortalMetadataDelete
}

// Exec executes the deletion query.
func (pmdo *PortalMetadataDeleteOne) Exec(ctx context.Context) error {
	n, err := pmdo.pmd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{portalmetadata.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (pmdo *PortalMetadataDeleteOne) ExecX(ctx context.Context) {
	pmdo.pmd.ExecX(ctx)
}
